Subject: Re: [PATCH] powerpc: Don't get PCI IRQ from OF for devices with no IRQ

From: Olaf Hering <[email-masked]>
Date: Sun, 8 Oct 2006 11:42:51 +0200

On Thu, Oct 05, Benjamin Herrenschmidt wrote:

> This patch adds checking of the PCI_INTERRUPT_PIN register before
> using standard OF parsing to retreive PCI interrupts. The reason is
> that some PCI devices may have no PCI interrupt, though they may have
> interrupts attached via other means. In this case, we shall not use
> irq->pdev, but device-specific code can later retreive those interrupts
> instead.
> 
> Without that patch, Maple and derivatives don't get the right interrupt
> for the second IDE channel as the linux IDE code fallsback to the PCI
> irq instead of trying to use the legacy ones for the on-board controller
> (which has no PCI_INTERRUPT_PIN). Having no PCI IRQ assign to it (as it
> doesn't request any) fixes it.

This breaks at least G5, IDE is probed twice, the first try uses IRQ 0.
SATA doesnt get an interrupt either.